"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadYAMLFile = exports.toYAML = void 0;

var _fs = require("fs");

var _jsYaml = require("js-yaml");

var _debug = _interopRequireDefault(require("debug"));

/* eslint-disable import/no-extraneous-dependencies */

/* covered by nuxt */
var debug = (0, _debug.default)("nuxt:netlify-cms");

var toYAML = function toYAML(object) {
  try {
    var yaml = (0, _jsYaml.safeDump)(object);
    return yaml;
  } catch (e) {
    /* istanbul ignore next */
    debug(e.message, e.name);
    return false;
  }
};

exports.toYAML = toYAML;

var loadYAMLFile = function loadYAMLFile(configFile) {
  try {
    var config = (0, _fs.readFileSync)(configFile, "utf8");
    var contents = (0, _jsYaml.safeLoad)(config, {
      filename: configFile,
      onWarning: debug
    });
    return contents;
  } catch (e) {
    /* istanbul ignore next */
    if (e.code !== "ENOENT") {
      debug(e.message, e.name);
    }

    return false;
  }
};

exports.loadYAMLFile = loadYAMLFile;